"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.composeWithPagination = composeWithPagination;

var _graphqlCompose = require("graphql-compose");

var _paginationResolver = require("./paginationResolver");

function composeWithPagination(typeComposer, opts) {
  if (!typeComposer || typeComposer.constructor.name !== 'TypeComposer') {
    throw new Error('You should provide TypeComposer instance to composeWithPagination method');
  }

  if (!opts) {
    throw new Error('You should provide non-empty options to composeWithPagination');
  }

  if (typeComposer.hasResolver('pagination')) {
    return typeComposer;
  }

  const resolver = (0, _paginationResolver.preparePaginationResolver)(typeComposer, opts);
  typeComposer.setResolver('pagination', resolver);
  return typeComposer;
}